VERSION 5.00
Begin VB.UserControl LineSymbiote 
   ClientHeight    =   660
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   660
   InvisibleAtRuntime=   -1  'True
   Picture         =   "LabeledLine.ctx":0000
   ScaleHeight     =   660
   ScaleWidth      =   660
   ToolboxBitmap   =   "LabeledLine.ctx":0C42
End
Attribute VB_Name = "LineSymbiote"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event LineSelected(ByVal x0 As Single, ByVal y0 As Single, ByVal x1 As Single, ByVal y1 As Single)

' The PictureBox on which we will draw.
Private WithEvents m_Canvas As PictureBox
Attribute m_Canvas.VB_VarHelpID = -1

' Drawing variables.
Private m_DrawMode As DrawModeConstants
Private m_Drawing As Boolean
Private m_X0 As Single
Private m_Y0 As Single
Private m_X1 As Single
Private m_Y1 As Single

' Start rubberband drawing.
Private Sub m_Canvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button <> vbLeftButton Then Exit Sub
    m_Drawing = True

    m_X0 = X
    m_Y0 = Y
    m_X1 = X
    m_Y1 = Y

    m_DrawMode = m_Canvas.DrawMode
    m_Canvas.DrawMode = vbInvert
    m_Canvas.Line (m_X0, m_Y0)-(m_X1, m_Y1)
End Sub


' Continue drawing.
Private Sub m_Canvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Drawing Then Exit Sub

    m_Canvas.Line (m_X0, m_Y0)-(m_X1, m_Y1)
    m_X1 = X
    m_Y1 = Y
    m_Canvas.Line (m_X0, m_Y0)-(m_X1, m_Y1)
End Sub


' Finish drawing.
Private Sub m_Canvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Drawing Then Exit Sub
    m_Drawing = False

    m_Canvas.Line (m_X0, m_Y0)-(m_X1, m_Y1)

    m_Canvas.DrawMode = m_DrawMode

    RaiseEvent LineSelected(m_X0, m_Y0, m_X1, m_Y1)
End Sub


Private Sub UserControl_Resize()
    UserControl.Width = UserControl.ScaleX(32, vbPixels, vbTwips)
    UserControl.Height = UserControl.ScaleY(32, vbPixels, vbTwips)
End Sub


' Return the PictureBox on which we will draw.
Public Property Get Canvas() As PictureBox
    Set Canvas = m_Canvas
End Property

' Set the PictureBox on which we will draw.
Public Property Set Canvas(ByVal New_Canvas As PictureBox)
    Set m_Canvas = New_Canvas
End Property

